package de.tudarmstadt.realtimebeverages.domain;

import static de.tudarmstadt.realtimebeverages.domain.AssertUtils.bigDecimalCompareTo;
import static org.assertj.core.api.Assertions.assertThat;

public class BoughtItemAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertBoughtItemAllPropertiesEquals(BoughtItem expected, BoughtItem actual) {
        assertBoughtItemAutoGeneratedPropertiesEquals(expected, actual);
        assertBoughtItemAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertBoughtItemAllUpdatablePropertiesEquals(BoughtItem expected, BoughtItem actual) {
        assertBoughtItemUpdatableFieldsEquals(expected, actual);
        assertBoughtItemUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertBoughtItemAutoGeneratedPropertiesEquals(BoughtItem expected, BoughtItem actual) {
        assertThat(expected)
            .as("Verify BoughtItem auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertBoughtItemUpdatableFieldsEquals(BoughtItem expected, BoughtItem actual) {
        assertThat(expected)
            .as("Verify BoughtItem relevant properties")
            .satisfies(e -> assertThat(e.getName()).as("check name").isEqualTo(actual.getName()))
            .satisfies(e -> assertThat(e.getPrice()).as("check price").usingComparator(bigDecimalCompareTo).isEqualTo(actual.getPrice()))
            .satisfies(e -> assertThat(e.getBoughtTime()).as("check boughtTime").isEqualTo(actual.getBoughtTime()))
            .satisfies(e -> assertThat(e.getBillingTime()).as("check billingTime").isEqualTo(actual.getBillingTime()))
            .satisfies(e -> assertThat(e.getPaidTime()).as("check billingTime").isEqualTo(actual.getPaidTime()))
            .satisfies(e -> assertThat(e.getAmount()).as("check amount").isEqualTo(actual.getAmount()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertBoughtItemUpdatableRelationshipsEquals(BoughtItem expected, BoughtItem actual) {
        assertThat(expected)
            .as("Verify BoughtItem relationships")
            .satisfies(e -> assertThat(e.getOffer()).as("check offer").isEqualTo(actual.getOffer()));
    }
}
